﻿
local addon, data = ...

local ReDAR = {
	Settings = {
		Enabled = true,
		HideInCombat = false,
		Crosshair = true,
		North = true,
		Rotate = true,
		DisplayDistance = true,
		Alpha = 1,
		IconSize = 20,
		OverlayCentre = {
			X = 0,
			Y = 0,
		},
	},
	UI = {
		Context = nil,
		Crosshair = nil,
		Nodes = {},
		FreeNodePool = {},
	},
	PlayerID = nil,
	PlayerCoords = {x=nil,y=nil,z=nil},
	PlayerFacing = 0,
	PlayerFacingX = 0,
	PlayerFacingZ = 0,
	PlayerFacingLast = 0,
	PlayerInCombat = false,
	Redraw = false,
	Resources = {},
	Lang = "English",
	NewCache = {},
}

ReDAR.profession_nodes = {
	l00000019 = "Original",
	l000000D9 = "Plants",
	l000000DA = "Wood",
	l000000DB = "Ore",
	l000000DC = "Fish",
}

ReDAR.resource_displays = {
	["English"] = {
		["Coastal Glory"] = { icon = "plant12.dds", },
		["Grieveblossom"] = { icon = "plant48.dds", },
		["Razorbrush"] = { icon = "plant43.dds", },
		["Duskglory"] = { icon = "plant2b.dds", },
		["Creeperbrush"] = { icon = "plant3.dds", },
		["Golden Nettle"] = { icon = "plant31a.dds", },
		["Wyvernspurr"] = { icon = "plant26.dds", },
		["Krakenweed"] = { icon = "plant34.dds", },
		["Tattertwist"] = { icon = "plant7c.dds", },
		["Roc Orchid"] = { icon = "plant33b.dds", },
		["Drakefoot"] = { icon = "plant26a.dds", },
		["Bloodshade"] = { icon = "plant40.dds", },
		["Basiliskweed"] = { icon = "plant30.dds", },
		["Tempestflower"] = { icon = "plant25a.dds", },
		["Twilight Bloom"] = { icon = "plant29.dds", },
		["Lucidflower"] = { icon = "plant22.dds", },
		["Frazzleweed"] = { icon = "plant36b.dds", },
		["Chimera's Cloak"] = { icon = "plant10a.dds", },

		["Tin Lode"] = { icon = "ore11a.dds", },
		["Copper Vein"] = { icon = "ore03a.dds", },
		["Silver Vein"] = { icon = "ore08.dds", },
		["Iron Vein"] = { icon = "ore03b.dds", },
		["Chromite Vein"] = { icon = "ore02a.dds", },
		["Gold Vein"] = { icon = "ore06a.dds", },
		["Cobalt Lode"] = { icon = "ore11b.dds", },
		["Titanium Vein"] = { icon = "ore07.dds", },
		["Platinum Deposit"] = { icon = "ore09.dds", },
		["Carmintium Deposit"] = { icon = "ore12.dds", },
		["Orichalcum"] = { icon = "ore17.dds", },
		["Karthite Vein"] = { icon = "ore13.dds", },
		["Gantimite Vein"] = { icon = "ore04b.dds", },
		["Rhenium Vein"] = { icon = "ore02.dds", },

		["Yew Log"] = { icon = "softwood.dds", },
		["Ashwood Log"] = { icon = "wood5.dds", },
		["Oak Log"] = { icon = "wood2.dds", },
		["Mahogany Log"] = { icon = "wood1a.dds", },
		["Kingswood Log"] = { icon = "wood4.dds", },
		["Runebirch Log"] = { icon = "runebirch_log_b.dds", },
		["Sagebrush Log"] = { icon = "sagebrush.dds", },
		["Shadethorn Branch"] = { icon = "wood5a.dds", },
		["Linden Timber"] = { icon = "wood8.dds", },
		["Elm Timber"] = { icon = "wood1.dds", },
		["Madrosa Timber"] = { icon = "wood6a.dds", },

		["School of Fish"] = { icon = "silverscale_perch.dds", },
		["School of Clever Fish"] = { icon = "fish_33_b.dds", },
		["School of Rare Fish"] = { icon = "fish_47.dds", },
		["School of Strangely Mutated Fish"] = { icon = "fish_46_c.dds", },
		["Sunken Boat"] = { icon = "dim_boat_01.dds", },

		["Artifact"] = { icon = "ench_material_15_b.dds", },
		["Twisted Artifact"] = { icon = "ench_material_15a.dds", },
		["Fae Yule Artifact"] = { icon = "giftbox1.dds", },
		["Unstable Artifact"] = { icon = "ench_material_15.dds", },
	},
	["German"] = {
		["Küstenpracht"] = { icon = "plant12.dds", },
		["Trauerblüte"] = { icon = "plant48.dds", },
		["Klingenstrauch"] = { icon = "plant43.dds", },
		["Dämmerruhm"] = { icon = "plant2b.dds", },
		["Kreuchstrauch"] = { icon = "plant3.dds", },
		["Goldnessel"] = { icon = "plant31a.dds", },
		["Lindwurmstachel"] = { icon = "plant26.dds", },
		["Krakenkraut"] = { icon = "plant34.dds", },
		["Krakengras"] = { icon = "plant34.dds", },
		["Fledderflecht"] = { icon = "plant7c.dds", },
		["Rokh-Orchideen"] = { icon = "plant33b.dds", },
		["Drakenfuß"] = { icon = "plant26a.dds", },
		["Blutschatten"] = { icon = "plant40.dds", },
		["Basiliskenkraut"] = { icon = "plant30.dds", },
		["Sturmblume"] = { icon = "plant25a.dds", },
		["Zwielichtblüte"] = { icon = "plant29.dds", },
		["Leuchtblume"] = { icon = "plant22.dds", },
		["Fransenkraut"] = { icon = "plant36b.dds", },
		["Chimeras Mantel"] = { icon = "plant10a.dds", },

		["Zinnader"] = { icon = "ore11a.dds", },
		["Kupferader"] = { icon = "ore03a.dds", },
		["Silberader"] = { icon = "ore08.dds", },
		["Eisenader"] = { icon = "ore03b.dds", },
		["Chromitader"] = { icon = "ore02a.dds", },
		["Goldader"] = { icon = "ore06a.dds", },
		["Kobaltader"] = { icon = "ore11b.dds", },
		["Titanader"] = { icon = "ore07.dds", },
		["Platin-Lager"] = { icon = "ore09.dds", },
		["Carmintium-Lager"] = { icon = "ore12.dds", },
		["Orichalcum"] = { icon = "ore17.dds", },
		["Tuthonyader"] = { icon = "ore13.dds", },
		["Gantimitader"] = { icon = "ore04b.dds", },
		["Rheniumader"] = { icon = "ore02.dds", },

		["Eibenstamm"] = { icon = "softwood.dds", },
		["Eschenholzstamm"] = { icon = "wood5.dds", },
		["Eichenstamm"] = { icon = "wood2.dds", },
		["Mahagoni-Stamm"] = { icon = "wood1a.dds", },
		["Königsholz-Stamm"] = { icon = "wood4.dds", },
		["Runenbirken-Stamm"] = { icon = "runebirch_log_b.dds", },
		["Salbeistamm"] = { icon = "sagebrush.dds", },
		["Schattendorn-Ast"] = { icon = "wood5a.dds", },
		["Linden holz"] = { icon = "wood8.dds", },
		["Ulmenholz"] = { icon = "wood1.dds", },
		["Madrosaholz"] = { icon = "wood6a.dds", },

		["Fischschwarm"] = { icon = "silverscale_perch.dds", },
		["Schwarm kluger Fische"] = { icon = "fish_33_b.dds", },
		["Schwarm seltener Fische"] = { icon = "fish_47.dds", },
		["Schwarm Seltsam Mutierter Fische"] = { icon = "fish_46_c.dds", },
		["Sunken Boat"] = { icon = "dim_boat_01.dds", },

		["Artefakt"] = { icon = "ench_material_15_b.dds", },
		["Verdrehtes Artefakt"] = { icon = "ench_material_15a.dds", },
		["Fae Yule Artifact"] = { icon = "giftbox1.dds", },
		["Unstable Artifact"] = { icon = "ench_material_15.dds", },
	},
	["French"] = {
		["Gloire côtière"] = { icon = "plant12.dds", },
		["Fleur-de-chagrin"] = { icon = "plant48.dds", },
		["Ronce tranchante"] = { icon = "plant43.dds", },
		["Gloire du couchant"] = { icon = "plant2b.dds", },
		["Ronce grimpante"] = { icon = "plant3.dds", },
		["Ortie dorée"] = { icon = "plant31a.dds", },
		["Ergot de wyverne"] = { icon = "plant26.dds", },
		["Herbe à kraken"] = { icon = "plant34.dds", },
		["Tournehaillon"] = { icon = "plant7c.dds", },
		["Orchiderokh"] = { icon = "plant33b.dds", },
		["Patte-de-drake"] = { icon = "plant26a.dds", },
		["Ombresang"] = { icon = "plant40.dds", },
		["Herbasilic"] = { icon = "plant30.dds", },
		["Fleur de la Tempête"] = { icon = "plant25a.dds", },
		["Fleur du crépuscule"] = { icon = "plant29.dds", },
		["Floralucida"] = { icon = "plant22.dds", },
		["Herbe calcinée"] = { icon = "plant36b.dds", },
		["Cape de la Chimère"] = { icon = "plant10a.dds", },

		["Veine de fer-blanc"] = { icon = "ore11a.dds", },
		["Veine de cuivre"] = { icon = "ore03a.dds", },
		["Veine de d'argent"] = { icon = "ore08.dds", },
		["Veine de fer"] = { icon = "ore03b.dds", },
		["Veine de Chromite"] = { icon = "ore02a.dds", },
		["Veine de d'or"] = { icon = "ore06a.dds", },
		["Veine de cobalt"] = { icon = "ore11b.dds", },
		["Veine de titane"] = { icon = "ore07.dds", },
		["Gisement de platine"] = { icon = "ore09.dds", },
		["Gisement de carmintium"] = { icon = "ore12.dds", },
		["Orichalque"] = { icon = "ore17.dds", },
		["Veine de tuthonie"] = { icon = "ore13.dds", },
		["Veine de gantimite"] = { icon = "ore04b.dds", },
		["Veine de rhénium"] = { icon = "ore02.dds", },
		["Veine en rhénium"] = { icon = "ore02.dds", },

		["Bûche d'if"] = { icon = "softwood.dds", },
		["Bûche de frêne"] = { icon = "wood5.dds", },
		["Bûche de chêne"] = { icon = "wood2.dds", },
		["Bûche d'acajou"] = { icon = "wood1a.dds", },
		["Bûche de bois royal"] = { icon = "wood4.dds", },
		["Bûche de rune-bouleau"] = { icon = "runebirch_log_b.dds", },
		["Bûche d'armoise"] = { icon = "sagebrush.dds", },
		["Branche d'ombrépine"] = { icon = "wood5a.dds", },
		["Branche de tilleul"] = { icon = "wood8.dds", },
		["Branche d'orme"] = { icon = "wood1.dds", },
		["Branche de madrosa"] = { icon = "wood6a.dds", },

		["Banc de poissons"] = { icon = "silverscale_perch.dds", },
		["Banc de poissons "] = { icon = "silverscale_perch.dds", },
		["Banc de poissons malins"] = { icon = "fish_33_b.dds", },
		["Banc de poissons rares"] = { icon = "fish_47.dds", },
		["Banc de poissons étrangement mutés"] = { icon = "fish_46_c.dds", },
		["Sunken Boat"] = { icon = "dim_boat_01.dds", },

		["Artefact"] = { icon = "ench_material_15_b.dds", },
		["Artefact altéré"] = { icon = "ench_material_15a.dds", },
		["Fae Yule Artifact"] = { icon = "giftbox1.dds", },
		["Unstable Artifact"] = { icon = "ench_material_15.dds", },
	},
}

local function name_to_display(name)
	if ReDAR.resource_displays[ReDAR.Lang] then
		if ReDAR.resource_displays[ReDAR.Lang][name] then
			return ReDAR.resource_displays[ReDAR.Lang][name].icon
		end
	end
	return nil
end

local function node_relative(node)
	if ReDAR.PlayerCoords.x then
		local x = (node.coordX - ReDAR.PlayerCoords.x) * 2
		local z = (node.coordZ - ReDAR.PlayerCoords.z) * 2

		if node.coordY == nil then
			node.coordY = ReDAR.PlayerCoords.y
		end

		local d = math.sqrt(math.pow(node.coordX - ReDAR.PlayerCoords.x, 2) + math.pow(node.coordY - ReDAR.PlayerCoords.y, 2) + math.pow(node.coordZ - ReDAR.PlayerCoords.z, 2))

		local h = node.coordY - ReDAR.PlayerCoords.y
			
		if ReDAR.Settings.Rotate then
			return (x * math.cos(ReDAR.PlayerFacing)) - (z * math.sin(ReDAR.PlayerFacing)), (z * math.cos(ReDAR.PlayerFacing)) + (x * math.sin(ReDAR.PlayerFacing)), d, h
		else
			return x, z, d, h
		end
	end
	return nil
end

function ReDAR.UnitAvailable(h, units)
	for id, type in pairs(units) do
		if type == "player" then
			ReDAR.PlayerID = id
			local p = Inspect.Unit.Detail("player")
			ReDAR.PlayerCoords.x = p.coordX
			ReDAR.PlayerCoords.y = p.coordY
			ReDAR.PlayerCoords.z = p.coordZ
		end
	end		
end

function ReDAR.UnitDetailCoord(h, xs, ys, zs)
	for unitid, x in pairs(xs) do
		if unitid == ReDAR.PlayerID then
			ReDAR.PlayerCoords.x = x
			ReDAR.Redraw = true
		end
	end

	for unitid, y in pairs(ys) do
		if unitid == ReDAR.PlayerID then
			ReDAR.PlayerCoords.y = y
			ReDAR.Redraw = true
		end
	end

	for unitid, z in pairs(zs) do
		if unitid == ReDAR.PlayerID then
			ReDAR.PlayerCoords.z = z
			ReDAR.Redraw = true
		end
	end
	if ReDAR.Settings.Rotate and (Inspect.Time.Frame() - ReDAR.PlayerFacingLast) > 0.1 then
		ReDAR.PlayerFacingLast = Inspect.Time.Frame()
		local deltaX = ReDAR.PlayerCoords.x - ReDAR.PlayerFacingX
		local deltaZ = ReDAR.PlayerFacingZ - ReDAR.PlayerCoords.z 
		if deltaX ~= 0 or deltaZ ~= 0 then
			ReDAR.PlayerFacingX = ReDAR.PlayerCoords.x
			ReDAR.PlayerFacingZ = ReDAR.PlayerCoords.z
			ReDAR.PlayerFacing = math.atan2(deltaZ, deltaX) - (math.pi / 2.0)
		end
		local northX = 0
		local northY = 0
		northX, northY = node_relative({coordX = ReDAR.PlayerCoords.x, coordZ = (ReDAR.PlayerCoords.z - 100)})
		ReDAR.UI.North:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER", northX, northY)
	end
end

function ReDAR.MapAdd(h, resources)
	for id, _ in pairs(resources) do
		local l = {}
		for token in string.gmatch(id, "[^,]+") do
			table.insert(l, token)
		end
		if ReDAR.profession_nodes[l[1]] ~= nil then
			ReDAR.Resources[id] = Inspect.Map.Detail(id)
			ReDAR.Redraw = true
		end
	end
end

function ReDAR.MapRemove(h, resources)
	for id, _ in pairs(resources) do
		if ReDAR.Resources[id] then
			ReDAR.Resources[id] = nil
			if ReDAR.UI.Nodes[id] then
				table.insert(ReDAR.UI.FreeNodePool, ReDAR.UI.Nodes[id])
				ReDAR.UI.Nodes[id]:SetVisible(false)
				ReDAR.UI.Nodes[id] = nil
			end
		end
	end
end

function ReDAR.UpdateUI(h)
	if ReDAR.Settings.Enabled and (ReDAR.Settings.HideInCombat == false or ReDAR.PlayerInCombat == false) and ReDAR.Redraw then
		local ToRemove = {}
		for id, detail in pairs(ReDAR.Resources) do
			local x, y, d, h = node_relative(detail)
			if x ~= nil then
				if ReDAR.UI.Nodes[id] == nil then
					local i = name_to_display(ReDAR.Resources[id].description)
					if i then
						if #ReDAR.UI.FreeNodePool > 0 then
							ReDAR.UI.Nodes[id] = ReDAR.UI.FreeNodePool[1]
							table.remove(ReDAR.UI.FreeNodePool, 1)
						else
							ReDAR.UI.Nodes[id] = UI.CreateFrame("Texture", "ReDAR_Node_"..id.."_Icon", ReDAR.UI.Overlay)
							ReDAR.UI.Nodes[id]:SetHeight(ReDAR.Settings.IconSize)
							ReDAR.UI.Nodes[id]:SetWidth(ReDAR.Settings.IconSize)
							ReDAR.UI.Nodes[id].DistanceFrame = UI.CreateFrame("Text", "ReDAR_Node_"..id.."_Distance", ReDAR.UI.Nodes[id])
							ReDAR.UI.Nodes[id].DistanceFrame:SetPoint("CENTERLEFT", ReDAR.UI.Nodes[id], "CENTERRIGHT")
							ReDAR.UI.Nodes[id].DistanceFrame:SetEffectGlow({strength = 3,})
						end

						ReDAR.UI.Nodes[id]:SetTexture("Rift", i)
						ReDAR.UI.Nodes[id]:SetVisible(true)
						ReDAR.UI.Nodes[id].DistanceFrame:SetVisible(ReDAR.Settings.DisplayDistance)
					end
				end
				if ReDAR.UI.Nodes[id] ~= nil then
					ReDAR.UI.Nodes[id]:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER", x, y)
					ReDAR.UI.Nodes[id].DistanceFrame:SetText(string.format("%dm", d))
					if math.abs(h/d) < 0.5 then
						ReDAR.UI.Nodes[id].DistanceFrame:SetFontColor(1, 1, 1)
					elseif h > 0 then
						ReDAR.UI.Nodes[id].DistanceFrame:SetFontColor(1, 0.5, 0.5)
					elseif h < 0 then
						ReDAR.UI.Nodes[id].DistanceFrame:SetFontColor(0.6, 0.6, 1)
					end
					ReDAR.UI.Nodes[id].DistanceFrame:SetVisible(ReDAR.Settings.DisplayDistance)
				end
			end
		end
	end
	ReDAR.Redraw = false
end


function ReDAR.CombatStart(h)
	ReDAR.PlayerInCombat = true
	ReDAR.UI.Overlay:SetVisible((ReDAR.Settings.Enabled and ReDAR.Settings.HideInCombat == false))
end

function ReDAR.CombatEnd(h)
	ReDAR.PlayerInCombat = false
	ReDAR.UI.Overlay:SetVisible(ReDAR.Settings.Enabled)
end

function ReDAR.CreateUI()
	ReDAR.Context = UI.CreateContext(addon.identifier)
	ReDAR.Height = UIParent:GetWidth()/4
	ReDAR.Width = ReDAR.Height
	ReDAR.UI.Overlay = UI.CreateFrame("Frame", "ReDAR.UI.Overlay", ReDAR.Context)
	ReDAR.UI.Overlay:SetHeight(ReDAR.Height)
	ReDAR.UI.Overlay:SetWidth(ReDAR.Width)
	ReDAR.UI.Overlay:SetPoint("CENTER", UIParent, "CENTER", ReDAR.Settings.OverlayCentre.X, ReDAR.Settings.OverlayCentre.Y)
	ReDAR.UI.Overlay:SetMouseMasking("limited")
	ReDAR.UI.Overlay:SetVisible(ReDAR.Settings.Enabled)
	ReDAR.UI.Crosshair = UI.CreateFrame("Text", "ReDAR.UI.Crosshair", ReDAR.UI.Overlay)
	ReDAR.UI.Crosshair:SetText("+")
	ReDAR.UI.Crosshair:SetFontSize(20)
	ReDAR.UI.Crosshair:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER")
	ReDAR.UI.Crosshair:SetLayer(3)
	ReDAR.UI.Crosshair:SetVisible(ReDAR.Settings.Crosshair)
	ReDAR.UI.Crosshair:SetMouseMasking("limited")
	ReDAR.UI.Crosshair:SetEffectGlow({strength = 3,})
	ReDAR.UI.North = UI.CreateFrame("Text", "ReDAR.UI.Crosshair", ReDAR.UI.Overlay)
	ReDAR.UI.North:SetText("N")
	ReDAR.UI.North:SetFontSize(30)
	ReDAR.UI.North:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER")
	ReDAR.UI.North:SetLayer(3)
	ReDAR.UI.North:SetVisible(ReDAR.Settings.North)
	ReDAR.UI.North:SetMouseMasking("limited")
	ReDAR.UI.North:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER", 0, -150)
	ReDAR.UI.North:SetEffectGlow({strength = 3,})
	ReDAR.UI.Dragbar = UI.CreateFrame("Frame", "ReDAR.UI.Dragbar", ReDAR.UI.Overlay)
	ReDAR.UI.Dragbar:SetHeight(30)
	ReDAR.UI.Dragbar:SetWidth(ReDAR.UI.Overlay:GetWidth())
	ReDAR.UI.Dragbar:SetPoint("TOPCENTER", ReDAR.UI.Overlay, "TOPCENTER")
	ReDAR.UI.Dragbar:SetBackgroundColor(0,0,0,0.5)
	ReDAR.UI.Dragbar:SetVisible(false)
	ReDAR.UI.DragText = UI.CreateFrame("Text", "ReDAR.UI.DragText", ReDAR.UI.Dragbar)
	ReDAR.UI.DragText:SetText("Resource Radar: Drag Me")
	ReDAR.UI.DragText:SetFontColor(0.8,0.8,0.8)
	ReDAR.UI.DragText:SetFontSize(24)
	ReDAR.UI.DragText:SetPoint("CENTER", ReDAR.UI.Dragbar, "CENTER")

	function ReDAR.UI.Dragbar.Event:LeftDown()
		self.MouseDown = true
		local mouseData = Inspect.Mouse()
		self.DragStartX = mouseData.x
		self.DragStartY = mouseData.y
	end

	function ReDAR.UI.Dragbar.Event:MouseMove(mouseX, mouseY)
		if self.MouseDown then
			ReDAR.Settings.OverlayCentre.X = ReDAR.Settings.OverlayCentre.X + mouseX - self.DragStartX
			ReDAR.Settings.OverlayCentre.Y = ReDAR.Settings.OverlayCentre.Y + mouseY - self.DragStartY
			self.DragStartX = mouseX
			self.DragStartY = mouseY
			ReDAR.UI.Overlay:SetPoint("CENTER", UIParent, "CENTER", ReDAR.Settings.OverlayCentre.X, ReDAR.Settings.OverlayCentre.Y) 
		end
	end

	function ReDAR.UI.Dragbar.Event:LeftUp()
		if self.MouseDown then
			self.MouseDown = false
		end
	end

	function ReDAR.UI.Dragbar.Event:LeftUpoutside()
		if self.MouseDown then
			self.MouseDown = false
		end
	end
end

function ReDAR.Init(h, addonid)
	if addonid == addon.identifier then
		if ReDAR_Settings then
			ReDAR.Settings = ReDAR_Settings
		end

		if ReDAR.Settings.IconSize == nil then
			ReDAR.Settings.IconSize = 20
		end

		if not ReDAR.Settings.OverlayCentre then
			ReDAR.Settings.OverlayCentre = {
				X = 0,
				Y = 0,
			}
		end

		if ReDAR.Settings.North == nil then
			ReDAR.Settings.North = false
		end

		if ReDAR.Settings.DisplayDistance == nil then
			ReDAR.Settings.DisplayDistance = false
		end

		if ReDAR.Settings.Alpha == nil then
			ReDAR.Settings.Alpha = 1
		end

		Command.Map.Monitor(ReDAR.Settings.Enabled)
		ReDAR.CreateUI()

		if ReDAR.Settings.HideInCombat == nil then
			ReDAR.Settings.HideInCombat = false
		end

		if ReDAR.Settings.Enabled then
			ReDAR.MapAdd(nil, Inspect.Map.List())
		end

		ReDAR.UI.Overlay:SetVisible(ReDAR.Settings.Enabled)

		ReDAR.Lang = Inspect.System.Language()
		if ReDAR.resource_displays[ReDAR.Lang] == nil then
			ReDAR.Lang = "English"
		end
	end
end

function ReDAR.SaveSettings(h, addonid)
	if addonid == addon.identifier then
		ReDAR_Settings = ReDAR.Settings
	end
end

function ReDAR.SlashHandler(h, args)
	argtable = {}
	for a in string.gmatch(args, "[^%s]+") do
		table.insert(argtable, a)
	end

	if #argtable < 1 then
		if ReDAR.Settings.Enabled then
			print("Disabling")
			ReDAR.Settings.Enabled = false
		else
			print("Enabling")
			ReDAR.Settings.Enabled = true
			ReDAR.Resources = {}
			ReDAR.MapAdd(nil, Inspect.Map.List())
		end
		Command.Map.Monitor(ReDAR.Settings.Enabled)
		ReDAR.UI.Overlay:SetVisible(ReDAR.Settings.Enabled)
	else
		if argtable[1] == "help" then
			print("/redar				toggles display")
			print("/redar crosshair		toggles crosshair display")
			print("/redar north			toggles north display")
			print("/redar rotate			toggles display rotation")
			print("/redar iconsize			displays the current icon size")
			print("/redar iconsize N		sets the current iconsize to N (10-100)")
			print("/redar iconsize default	sets the current iconsize to 20")
			print("/redar position		displays current offset from centre of screen")
			print("/redar position x y		sets the current offset from centre to x,y")
			print("/redar position drag	toggles the drag frame for positioning (left click drag bar to move)")
			print("/redar position default	sets the current offset to 0,0")
			print("/redar distance          toggles distance to node display")
			print("/redar alpha		displays the current alpha")
			print("/redar alpha x		sets the alpha value to x")
			print("/redar hideincombat	toggles hiding display when in combat")
		elseif argtable[1] == "crosshair" then
			ReDAR.Settings.Crosshair = not ReDAR.Settings.Crosshair
			ReDAR.UI.Crosshair:SetVisible(ReDAR.Settings.Crosshair)
			print(string.format("Toggling crosshair: %s", tostring(ReDAR.Settings.Crosshair)))
		elseif argtable[1] == "north" then
			ReDAR.Settings.North = not ReDAR.Settings.North
			ReDAR.UI.North:SetVisible(ReDAR.Settings.North)
			print(string.format("Toggling north: %s", tostring(ReDAR.Settings.North)))
		elseif argtable[1] == "rotate" then
			ReDAR.Settings.Rotate = not ReDAR.Settings.Rotate
			print(string.format("Toggling rotate: %s", tostring(ReDAR.Settings.Rotate)))
			ReDAR.UI.North:SetPoint("CENTER", ReDAR.UI.Overlay, "CENTER", 0, -200)
			ReDAR.Redraw = true
		elseif argtable[1] == "iconsize" then
			if #argtable > 1 then
				local newsize = 20
				if argtable[2] == "default" then
					newsize = 20
				else
					newsize = tonumber(argtable[2])
				end

				if newsize == nil then
					print(string.format("Iconsize: argument \"%s\" not a number!", argtable[2]))
				else
					if newsize < 10 or newsize > 100 then
						print(string.format("Iconsize: Size %d out of bounds (10-100).", newsize))
					else
						print(string.format("Iconsize: Now set to %d (was %d)", newsize, ReDAR.Settings.IconSize))
						ReDAR.Settings.IconSize = newsize
						for _, node in pairs(ReDAR.UI.Nodes) do
							node:SetHeight(ReDAR.Settings.IconSize)
							node:SetWidth(ReDAR.Settings.IconSize)
						end
						for _, node in ipairs(ReDAR.UI.FreeNodePool) do
							node:SetHeight(ReDAR.Settings.IconSize)
							node:SetWidth(ReDAR.Settings.IconSize)
						end
					end
				end
			else
				print(string.format("Iconsize: Currently %d", ReDAR.Settings.IconSize))
			end
		elseif argtable[1] == "position" then
			if #argtable == 3 then
				local newx = tonumber(argtable[2])
				local newy = tonumber(argtable[3])
				if newx and newy then
					ReDAR.Settings.OverlayCentre.X = newx
					ReDAR.Settings.OverlayCentre.Y = newy
				else
					print("Invalid position offset")
				end
				ReDAR.UI.Overlay:SetPoint("CENTER", UIParent, "CENTER", ReDAR.Settings.OverlayCentre.X, ReDAR.Settings.OverlayCentre.Y)
			elseif argtable[2] == "default" then
				ReDAR.Settings.OverlayCentre.X = 0
				ReDAR.Settings.OverlayCentre.Y = 0
				ReDAR.UI.Overlay:SetPoint("CENTER", UIParent, "CENTER", ReDAR.Settings.OverlayCentre.X, ReDAR.Settings.OverlayCentre.Y)
			elseif argtable[2] == "drag" then
				if ReDAR.UI.Dragbar:GetVisible() then
					print("Drag disabled")
					ReDAR.UI.Dragbar:SetVisible(false)
					ReDAR.UI.Overlay:SetBackgroundColor(0,0,0,0)
				else
					print("Drag enabled")
					ReDAR.UI.Dragbar:SetVisible(true)
					ReDAR.UI.Overlay:SetBackgroundColor(0,0,0,0.5)
				end
			else
				print(string.format("Position: X: %d, Y: %d", ReDAR.Settings.OverlayCentre.X, ReDAR.Settings.OverlayCentre.Y))
			end
		elseif argtable[1] == "distance" then
			ReDAR.Settings.DisplayDistance = not ReDAR.Settings.DisplayDistance
			print(string.format("Toggling distance display: %s", tostring(ReDAR.Settings.DisplayDistance)))
			ReDAR.Redraw = true
		elseif argtable[1] == "alpha" then
			if #argtable == 2 then
				local v = tonumber(argtable[2])
				if v ~= nil and v >= 0 and v <= 100 then
					ReDAR.Settings.Alpha = v / 100
					ReDAR.UI.Overlay:SetAlpha(ReDAR.Settings.Alpha)
				else
					print("Alpha must be in the range 0-100")
				end
			else
				print(string.format("Alpha: %d%%", ReDAR.Settings.Alpha * 100))
			end
		elseif argtable[1] == "hideincombat" then
			if ReDAR.Settings.HideInCombat then
				ReDAR.Settings.HideInCombat = false
				print("Hide In Combat disabled")
			else
				ReDAR.Settings.HideInCombat = true
				print("Hide In Combat enabled")
			end
		end
	end

end

Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, ReDAR.SaveSettings, "ReDAR.SaveSettings")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, ReDAR.Init, "ReDAR.Init")
Command.Event.Attach(Event.Unit.Detail.Coord, ReDAR.UnitDetailCoord, "ReDAR.UnitDetailCoord")
Command.Event.Attach(Event.Unit.Availability.Full, ReDAR.UnitAvailable, "ReDAR.UnitAvailable")
Command.Event.Attach(Event.Map.Add, ReDAR.MapAdd, "ReDAR.MapAdd")
Command.Event.Attach(Event.Map.Remove, ReDAR.MapRemove, "ReDAR.MapRemove")
Command.Event.Attach(Event.System.Update.Begin, ReDAR.UpdateUI, "ReDAR.UpdateUI")
Command.Event.Attach(Event.System.Secure.Enter, ReDAR.CombatStart, "ReDAR.CombatStart")
Command.Event.Attach(Event.System.Secure.Leave, ReDAR.CombatEnd, "ReDAR.CombatStart")
Command.Event.Attach(Command.Slash.Register("redar"), ReDAR.SlashHandler, "Slash Command")
